<?php
/*
Plugin Name: FAQ Accordion
Plugin URI: http://www.orangedevdesign.nl/nieuws/wordpress-faq-accordion/
Description: FAQ Accordion made by <a href="http://www.orangedevdesign.nl" title="webdesign">Orange Dev Design</a>
Author: Dennis de Groot
Version: 1.1.1
Author URI: http://www.orangedevdesign.nl
*/
add_action('admin_print_scripts', 'call_editor' );
wp_enqueue_style('odd_faq_css', WP_PLUGIN_URL.'/faq-accordion/style.css', array(), '1.1.1');
wp_enqueue_script('odd_faq_js', WP_PLUGIN_URL.'/faq-accordion/slide.js', array(), '1.1.1',true);

add_shortcode('odd_faq', 'get_questions');

function call_editor()
{
	wp_enqueue_script('editor');
	wp_enqueue_script('thickbox');
	add_action( 'admin_head', 'wp_tiny_mce' );
}

//Install table for FAQ
function oddfaq_install()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "oddfaq";

	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name)
	{
		$sql = "CREATE TABLE " . $table_name . " (
		faq_id mediumint(9) NOT NULL AUTO_INCREMENT,
		faq_question text NOT NULL,
		faq_answer text NOT NULL,
		faq_group int NOT NULL,
		UNIQUE KEY id (faq_id)
		);";
	}
	else
	{
		$sql = "ALTER TABLE  `wp_oddfaq` ADD `faq_group` INT NOT NULL";
	}
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);

	add_option("oddfaq_version", "1.1.1");
}
register_activation_hook(__FILE__,'oddfaq_install');

function oddfaq_uninstall()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "oddfaq";

	delete_option("oddfaq_version");
	$wpdb->query("DROP TABLE IF EXISTS $table_name");
}
register_deactivation_hook( __FILE__, 'oddfaq_uninstall' );

//Create admin menu
function add_admin_panel(){
	add_menu_page('FAQ Accordion', 'FAQ',6,'odd-faq-accordion');
	add_submenu_page('odd-faq-accordion', 'Questions', 'Questions', 6, 'odd-faq-accordion','odd_faq_questions');
	add_submenu_page('odd-faq-accordion', 'Add question', 'Add question', 6, 'odd-add-question','odd_add');
	add_submenu_page('odd-faq-accordion', 'Groups', 'Groups', 6, 'odd-faq-groups','odd_faq_questions');
	add_submenu_page('odd-faq-accordion', 'Add group', 'Add group', 6, 'odd-add-group','odd_add');
}
add_action('admin_menu', 'add_admin_panel');

//FAQ actions
function odd_faq_questions()
{
	$id = absint($id);

	if($_POST['delete'])
	{
		$id = htmlspecialchars(addslashes($_POST['delete_id']));
		odd_delete($id);
		odd_faq_overview();
	}
	elseif($_POST['edit'])
	{
		$id = htmlspecialchars(addslashes($_POST['edit_id']));
		odd_edit($id);
	}
	elseif($_POST['save_edit'])
	{
		$id = htmlspecialchars(addslashes($_POST['save_edit_id']));
		odd_edit($id);
	}
	else
	{
		odd_faq_overview();
	}
}

//FAQ overview
function odd_faq_overview()
{
	global $wpdb;
	$id = absint($id);
	?>
		<div class="wrap">
			<div id="icon-edit" class="icon32"></div>
			<h2><?php echo ($_GET['page'] == 'odd-faq-accordion')?('FAQ Questions'):('FAQ Groups');?></h2>
			<table id="archives-month" class="widefat">
				<thead>
					<tr>
						<th><?php echo ($_GET['page'] == 'odd-faq-accordion')?('Id'):('Group id');?></th>
						<th><?php echo ($_GET['page'] == 'odd-faq-accordion')?('Question'):('Group');?></th>
						<th>Edit</th>
						<th>Delete</th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<th><?php echo ($_GET['page'] == 'odd-faq-accordion')?('Id'):('Group id');?></th>
						<th><?php echo ($_GET['page'] == 'odd-faq-accordion')?('Question'):('Group');?></th>
						<th>Edit</th>
						<th>Delete</th>
					</tr>
				</tfoot>
				<tbody>
				<?php 
					if($_GET['page'] == 'odd-faq-accordion')
					{
						$table_name = $wpdb->prefix.'oddfaq';
						$query = $wpdb->get_results("SELECT * FROM $table_name WHERE faq_group != 0",ARRAY_A);
						$questions = array();
	
						foreach($query as $result)
						{
							array_push($questions, array('faq_id' => $result['faq_id'],
														 'faq_question' => $result['faq_question'],
														 'faq_answer' => $result['faq_answer']));
						}
	
						foreach($questions as $question)
						{
							echo '<form action="" method="post">';
							echo '<tr>';
							echo '<td>'.$question['faq_id'].'</td>';
							echo '<td>'.$question['faq_question'].'</td>';
							echo '<td><input name="edit" type="submit" value="Edit" /><input name="edit_id" type="hidden" value="'.$question['faq_id'].'" /></td>';
							echo '<td><input name="delete" type="submit" value="Delete" /><input name="delete_id" type="hidden" value="'.$question['faq_id'].'" /></td>';
							echo '</tr>';
							echo '</form>';
						}
					}
					else
					{
						$table_name = $wpdb->prefix.'oddfaq';
						$query = $wpdb->get_results("SELECT * FROM $table_name WHERE faq_group = 0",ARRAY_A);
						$questions = array();
	
						foreach($query as $result)
						{
							array_push($questions, array('group_id' => $result['faq_id'],
														 'group_name' => $result['faq_question']));
						}
	
						foreach($questions as $question)
						{
							echo '<form action="" method="post">';
							echo '<tr>';
							echo '<td>'.$question['group_id'].'</td>';
							echo '<td>'.$question['group_name'].'</td>';
							echo '<td><input name="edit" type="submit" value="Edit" /><input name="edit_id" type="hidden" value="'.$question['group_id'].'" /></td>';
							echo '<td><input name="delete" type="submit" value="Delete" /><input name="delete_id" type="hidden" value="'.$question['group_id'].'" /></td>';
							echo '</tr>';
							echo '</form>';
						}
					};?>
				</tbody>
				</table>
		</div>
	<?php
}

//Add row to database
function odd_add()
{
	global $wpdb;
	$table_name = $wpdb->prefix.'oddfaq';

	if($_POST['add'])
	{
		if($_GET['page'] == 'odd-add-question')
		{
			$wpdb->query("INSERT INTO $table_name (faq_question, faq_answer, faq_group) VALUES ('".$_POST['odd_question']."', '".$_POST['odd_answer']."', '".$_POST['odd_group_id']."')");
			odd_edit(mysql_insert_id());
		}
		else
		{
			$wpdb->query("INSERT INTO $table_name (faq_question, faq_group) VALUES ('".$_POST['odd_question']."', 0)");
			odd_edit(mysql_insert_id());
		}
	}
	else
	{
		echo '<div class="wrap">';
		echo '<div id="icon-edit-pages" class="icon32"><br /></div>';
		echo ($_GET['page'] == 'odd-add-question')?('<h2>Add new question</h2>'):('<h2>Add new group</h2>');
		echo '<div id="poststuff">';
		echo '<form action="" method="post">';
		echo '<div id="post-body">';
		echo '<div id="post-body-content">';
		echo '<div id="titlediv">';
		echo '<div id="titlewrap">';
		echo '<input type="text" name="odd_question" size="30" tabindex="1" value="" id="title" autocomplete="off" /> ';

		if($_GET['page'] == 'odd-add-question')
		{
			the_editor('','odd_answer');
			echo '<p><strong>Group</strong></p>';
			echo '<select name="odd_group_id">';

			$query = $wpdb->get_results("SELECT * FROM $table_name WHERE faq_group = 0",ARRAY_A);
			$groups = array();

			foreach($query as $result)
			{
				array_push($groups, array('group_id' => $result['faq_id'],
										  'group_name' => $result['faq_question']));
			}

			foreach($groups as $group)
			{
				echo '<option value="'.$group['group_id'].'">'.$group['group_name'].'</option>';
			}

			echo '</select>';
		}
		echo '</div></div></div></div></div>';
		?><input type="submit" name="add" class="button-primary" value="<?php _e('Save Changes') ?>" /><?php
		echo '</form>';
		echo '</div>';
	}
}

function odd_edit($id)
{
	global $wpdb;
	$table_name = $wpdb->prefix.'oddfaq';
	$id = absint($id);

	if($_POST['save_edit'])
	{	
		$wpdb->query("UPDATE $table_name SET faq_question = '".$_POST['odd_question']."', faq_answer = '".$_POST['odd_answer']."' WHERE faq_id = $id");
	}

	$query = $wpdb->get_results("SELECT * FROM $table_name WHERE faq_id = $id",ARRAY_A);
	$questions = array();

	foreach($query as $result)
	{
		array_push($questions, array('faq_id' => $result['faq_id'],
									 'faq_question' => $result['faq_question'],
									 'faq_answer' => $result['faq_answer']));
	}

	foreach($questions as $question)
	{
		echo '<div class="wrap">';
		echo '<div id="icon-edit-pages" class="icon32"><br /></div>';
		echo ($_GET['page'] == 'odd-add-question')?('<h2>Edit question</h2>'):('<h2>Edit group</h2>');
		echo '<div id="poststuff">';
		echo '<form action="" method="post">';
		echo '<div id="post-body">';
		echo '<div id="post-body-content">';
		echo '<div id="titlediv">';
		echo '<div id="titlewrap">';
		echo '<input type="text" name="odd_question" size="30" tabindex="1" value="'.$question['faq_question'].'" id="title" autocomplete="off" /> ';
		if($_GET['page'] == 'odd-add-question' || $_GET['page'] == 'odd-faq-accordion')
		{
			the_editor($question['faq_answer'],'odd_answer');
			echo '<p><strong>Group</strong></p>';
			echo '<select name="odd_group_id">';

			$query = $wpdb->get_results("SELECT * FROM $table_name WHERE faq_group = 0",ARRAY_A);
			$groups = array();

			foreach($query as $result)
			{
				array_push($groups, array('group_id' => $result['faq_id'],
										  'group_name' => $result['faq_question']));
			}

			foreach($groups as $group)
			{
				echo '<option value="'.$group['group_id'].'">'.$group['group_name'].'</option>';
			}

			echo '</select>';
		}
		echo '</div></div></div></div></div>';
		?><input type="submit" name="save_edit" class="button-primary" value="<?php _e('Save Changes') ?>" /><?php
		echo '<input name="save_edit_id" type="hidden" value="'.$question['faq_id'].'" />';
		echo '</form>';
		echo '</div>';
	}
}

//Delete row from database
function odd_delete($id)
{
	global $wpdb;
	$table_name = $wpdb->prefix.'oddfaq';
	$id = absint($id);

	$wpdb->query("DELETE FROM $table_name WHERE faq_id = '$id'");
}

//Frontend
function get_questions($id = 0)
{
	global $wpdb;
	$table_name = $wpdb->prefix.'oddfaq';
	$select_query = "SELECT * FROM $table_name WHERE faq_group != 0";
	
	extract(shortcode_atts(array('id' => $id,), $id));
	if($id != 0)
	{
		$select_query .= " AND faq_group = $id";
	}
	$query = $wpdb->get_results($select_query,ARRAY_A);
	$questions = array();
	
	$faq = '';

	foreach($query as $result)
	{
		array_push($questions, array('faq_id' => $result['faq_id'],
									 'faq_question' => $result['faq_question'],
									 'faq_answer' => $result['faq_answer']));
	}

	$faq = '<div id="odd-faq">';
	foreach($questions as $question)
	{
		$faq .= '<div class="odd-faq-question">';
		$faq .= $question['faq_question'];
		$faq .= '</div>';
		$faq .= '<div class="odd-faq-answer">'.$question['faq_answer'].'</div>';
	}
	$faq .= '</div>';
	
	// Please don't remove this, I just want a little bit credits for the time I put in the plugin.
	// You have any suggestions or errors, place them here: http://www.orangedevdesign.nl/nieuws/wordpress-faq-accordion/ 
	// or e-mail them to info@orangedevdesign.nl
	$faq .= '<small style="width:100%; float:left;">FAQ Accordion by <a href="http://www.orangedevdesign.nl/" title="Webdesign" target="_blank" style="text-decoration:none;">OrangeDevDesign</a></small>';
	
	return $faq;
}
?>